Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3791)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3792)
@@ -6080,106 +3636,30 @@
       IMPLICIT NONE
 
-      INTEGER(iwp) ::  nzt_topo_nestbc   !<
-
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                                      INTENT(INOUT) ::  f             !<
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
-                                      INTENT(IN)    ::  fc            !<
-      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nxl:nxr),          &
-                                      INTENT(IN)    ::  logc_ratio    !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x           !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x           !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y           !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y           !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z           !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z           !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z           !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z           !<
-
-      
-      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic    !<
-      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc    !<
-!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc    !<
-      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                &
-                                          INTENT(IN)           ::  logc  !<
-      INTEGER(iwp), DIMENSION(1:2,nxl:nxr), INTENT(IN)         ::  logc_kbounds  !< 
-
-      INTEGER(iwp) :: kct
-!AH
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH
-
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f   !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc  !< Parent-grid array
+      INTEGER(iwp) :: kct                                     !< The parent-grid index in z-direction just below the boundary value node
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl  !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu  !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain parent cell - z direction
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 's' or 'n' 
       CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
-      
+!
+!--   Local variables:      
       INTEGER(iwp) ::  i        !< Running index in the x-direction
-      INTEGER(iwp) ::  iinc     !<
-      INTEGER(iwp) ::  icorr    !<
-      INTEGER(iwp) ::  ico      !<
       INTEGER(iwp) ::  ierr     !< MPI error code
-      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
-      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
-      INTEGER(iwp) ::  i1       !<
-      INTEGER(iwp) ::  j        !< Lower bound of the running index ja
-      INTEGER(iwp) ::  ja       !< Index in y-direction running over the parent-grid cell on the boundary 
-      INTEGER(iwp) ::  jaw      !< Reduced ja-index for workarr_sn
-      INTEGER(iwp) ::  jawbc    !< jaw-index pointing to the boundary-value nodes (either 0 or jgsr-1)
-!AH      INTEGER(iwp) ::  jbeg     !< j-index pointing to the starting point of workarr_sn in the j-direction
       INTEGER(iwp) ::  jb       !< Fixed j-index pointing to the node just behind the boundary-value node
       INTEGER(iwp) ::  jbc      !< Fixed j-index pointing to the boundary-value nodes (either j or jend)
       INTEGER(iwp) ::  jbgp     !< Index running over the redundant boundary ghost points in j-direction
-      INTEGER(iwp) ::  jend     !< Upper bound of the running index ja
-      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
       INTEGER(iwp) ::  k        !< Running index in the z-direction
-      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
-      INTEGER(iwp) ::  kcorr    !<
-      INTEGER(iwp) ::  kco      !<
-      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
-      INTEGER(iwp) ::  k1       !<
       INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
-      INTEGER(iwp) ::  lp1      !< l+1
-      INTEGER(iwp) ::  lrightu  !< Upshift by one for the upper bound of index l in case of var == 'u'
-      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
       INTEGER(iwp) ::  mbeg     !< m-index pointing to the starting point of workarrc_sn in the m-direction 
-      INTEGER(iwp) ::  moff     !< m-offset needed on the north boundary to correctly refer to boundary ghost points
-      INTEGER(iwp) ::  mp1      !< m+1
-      INTEGER(iwp) ::  mw       !< Reduced m-index for workarrc_sn
+      INTEGER(iwp) ::  mw       !< Reduced m-index for workarrc_sn pointing to the boundary ghost node 
+      INTEGER(iwp) ::  mwp      !< Reduced m-index for workarrc_sn pointing to the first prognostic node
       INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
-      INTEGER(iwp) ::  np1      !< n+1
-      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
-      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
-
-      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
-      REAL(wp) ::  cellsumd     !< Sum of differences over the anterpolation cell 
-      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
-      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
-      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
-
-!      real(wp), parameter :: c1 =  2.0_wp / 6.0_wp
-!      real(wp), parameter :: c2 =  5.0_wp / 6.0_wp
-!      real(wp), parameter :: c3 = -1.0_wp / 6.0_wp
+      REAL(wp) ::  cb           !< Interpolation coefficient for the boundary ghost node  
+      REAL(wp) ::  cp           !< Interpolation coefficient for the first prognostic node
+      REAL(wp) ::  f_interp_1   !< Value interpolated in y direction from the parent-grid data
+      REAL(wp) ::  f_interp_2   !< Auxiliary value interpolated in y direction from the parent-grid data
 
 !
@@ -6189,69 +3669,41 @@
 !--      For v, nys is a ghost node, but not for the other variables
          IF ( var == 'v' )  THEN
-            j     = nys
-            jend  = nys 
-            jawbc = 0
             jbc   = nys
             jb    = jbc - 1
-            m     = jcs + 2
             mw    = 2
+            mwp   = 2         ! This is redundant when var == 'v'
             mbeg  = jcs
-            moff  = 0
          ELSE
-            j     = nys - jgsr
-            jend  = nys - 1
-            jawbc = jgsr - 1
             jbc   = nys - 1
             jb    = jbc - 1
-            m     = jcs + 1
             mw    = 1
+            mwp   = 2
             mbeg  = jcs
-            moff  = 0
          ENDIF
       ELSEIF ( edge == 'n' )  THEN
          IF ( var == 'v' )  THEN
-            j     = nyn + 1
-            jend  = nyn + 1
-            jawbc = 0
             jbc   = nyn + 1
             jb    = jbc + 1
-            m     = jcn - 1
             mw    = 1
+            mwp   = 0         ! This is redundant when var == 'v'     
             mbeg  = jcn - 2
-            moff  = 0
          ELSE
-            j     = nyn + 1
-            jend  = nyn + jgsr
-            jawbc = 0
             jbc   = nyn + 1
             jb    = jbc + 1
-            m     = jcn - 1
             mw    = 1
+            mwp   = 0
             mbeg  = jcn - 2
-            moff  = 1
          ENDIF
       ENDIF
-
-      IF  ( var == 'w' )  THEN
-         ntopw = 1
+!
+!--   Interpolation coefficients
+      IF  ( interpolation_scheme_lrsn == 1 )  THEN
+         cb = 1.0_wp  ! 1st-order upwind 
+      ELSE IF  ( interpolation_scheme_lrsn == 2 )  THEN
+         cb = 0.5_wp  ! 2nd-order central
       ELSE
-         ntopw = 0
-      ENDIF
-
-      IF  ( var == 'u' )  THEN
-         lrightu = 0
-      ELSE
-         lrightu = 1
-      ENDIF
-
-      IF ( var == 'u' )  THEN 
-         var_flag = 1 
-      ELSEIF ( var == 'v' )  THEN
-         var_flag = 2 
-      ELSEIF ( var == 'w' )  THEN
-         var_flag = 3
-      ELSE
-         var_flag = 0
-      ENDIF
+         cb = 0.5_wp  ! 2nd-order central (default)
+      ENDIF         
+      cp    = 1.0_wp - cb
 !
 !--   Substitute the necessary parent-grid data to the work array workarrc_sn. 
@@ -6293,18 +3745,38 @@
       ENDIF
 
-      IF  ( var == 'u' )  THEN
+      IF  ( var == 'v' )  THEN
+
+         DO  l = iclw, icrw
+            DO n = 0, kct 
+               
+               DO  i = ifl(l), ifu(l)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,jbc,i) = workarrc_sn(n,mw,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'u' )  THEN
          
          DO  l = iclw, icrw-1
-            DO n = 0, kct 
+            DO n = 0, kct
+!
+!--            First interpolate to the flux point
+               f_interp_1 = cb * workarrc_sn(n,mw,l)   + cp * workarrc_sn(n,mwp,l)
+               f_interp_2 = cb * workarrc_sn(n,mw,l+1) + cp * workarrc_sn(n,mwp,l+1)
 !
 !--            Use averages of the neighbouring matching grid-line values
                DO  i = ifl(l), ifl(l+1)
-                  f(kfl(n):kfu(n),jbc,i) = 0.5_wp * ( workarrc_sn(n,mw,l)       &
-                       +  workarrc_sn(n,mw,l+1) )
+!                  f(kfl(n):kfu(n),jbc,i) = 0.5_wp * ( workarrc_sn(n,mw,l)       &
+!                       +  workarrc_sn(n,mw,l+1) )
+                  f(kfl(n):kfu(n),jbc,i) = 0.5_wp * ( f_interp_1 + f_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
                IF  ( MOD( ifl(l), igsr ) == 0 )  THEN
-                  f(kfl(n):kfu(n),jbc,ifl(l)) = workarrc_sn(n,mw,l)
+!                  f(kfl(n):kfu(n),jbc,ifl(l)) = workarrc_sn(n,mw,l)
+                  f(kfl(n):kfu(n),jbc,ifl(l)) = f_interp_1
                ENDIF
 
@@ -6314,6 +3786,8 @@
 !--      Finally, set the values along the last matching grid-line  
          IF  ( MOD( ifl(icrw), igsr ) == 0 )  THEN
+            f_interp_1 = cb * workarrc_sn(n,mw,icrw) + cp * workarrc_sn(n,mwp,icrw)
             DO  n = 0, kct
-               f(kfl(n):kfu(n),jbc,ifl(icrw)) = workarrc_sn(n,mw,icrw)
+!               f(kfl(n):kfu(n),jbc,ifl(icrw)) = workarrc_sn(n,mw,icrw)
+               f(kfl(n):kfu(n),jbc,ifl(icrw)) = f_interp_1
             ENDDO
          ENDIF
@@ -6335,7 +3809,11 @@
          DO  l = iclw, icrw
             DO n = 0, kct + 1   ! It is important to go up to kct+1  
+!
+!--            Interpolate to the flux point
+               f_interp_1 = cb * workarrc_sn(n,mw,l) + cp * workarrc_sn(n,mwp,l)
 !                  
 !--            First substitute only the matching-node values                 
-               f(kfu(n),jbc,ifl(l):ifu(l)) = workarrc_sn(n,mw,l)
+!               f(kfu(n),jbc,ifl(l):ifu(l)) = workarrc_sn(n,mw,l)
+               f(kfu(n),jbc,ifl(l):ifu(l)) = f_interp_1
 
             ENDDO
@@ -6354,12 +3832,15 @@
          ENDDO
 
-      ELSE   ! v or scalars
+      ELSE   ! Any scalar
          
          DO  l = iclw, icrw
             DO n = 0, kct 
-               
+!
+!--            Interpolate to the flux point
+               f_interp_1 = cb * workarrc_sn(n,mw,l) + cp * workarrc_sn(n,mwp,l)
                DO  i = ifl(l), ifu(l)
                   DO  k = kfl(n), kfu(n)
-                     f(k,jbc,i) = workarrc_sn(n,mw,l)
+!                     f(k,jbc,i) = workarrc_sn(n,mw,l)
+                     f(k,jbc,i) = f_interp_1
                   ENDDO
                ENDDO
@@ -6385,8 +3866,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,       &
-                                  r1z, r2z, kct, ifl, ifu, jfl, jfu, kfl, kfu, &
-                                  ijkfc, var )
-
+   SUBROUTINE pmci_interp_1sto_t( f, fc, kct, ifl, ifu, jfl, jfu, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
@@ -6394,111 +3872,53 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
-                                      INTENT(INOUT) ::  f     !< Child-grid array
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
-                                      INTENT(IN)    ::  fc    !< Parent-grid array
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x   !<
-      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x   !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y   !<
-      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y   !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z   !<
-!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z   !<
-      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z   !<
-
-      
-      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  ic    !<
-      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  jc    !<
-!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  kc    !<
-      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  kc    !<
-
-      INTEGER(iwp) :: kct
-!AH
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-
-      CHARACTER(LEN=1), INTENT(IN) :: var   !<
-
-      INTEGER(iwp) ::  i    !<
-      INTEGER(iwp) ::  ib   !<
-      INTEGER(iwp) ::  iclc !< Lower i-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  icrc !< Upper i-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  ie   !<
-      INTEGER(iwp) ::  ierr !< MPI error code
-      INTEGER(iwp) ::  ijk  !<
-      INTEGER(iwp) ::  iw   !<
-      INTEGER(iwp) ::  j    !<
-      INTEGER(iwp) ::  jb   !<
-      INTEGER(iwp) ::  jcsc !< Lower j-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  jcnc !< Upper j-index limit for copying fc-data to workarrc_t
-      INTEGER(iwp) ::  je   !< 
-      INTEGER(iwp) ::  jw   !<     
-      INTEGER(iwp) ::  k    !< Vertical child-grid index fixed to the boundary-value level 
-      INTEGER(iwp) ::  ka   !< Running vertical child-grid index
-      INTEGER(iwp) ::  kw   !< 
-      INTEGER(iwp) ::  l    !< Parent-grid index in x-direction
-      INTEGER(iwp) ::  lp1  !< l+1
-      INTEGER(iwp) ::  m    !< Parent-grid index in y-direction
-      INTEGER(iwp) ::  mp1  !< m+1
-      INTEGER(iwp) ::  n    !< Parent-grid work array index in z-direction
-      INTEGER(iwp) ::  np1  !< n+1
-      INTEGER(iwp) ::  noff !< n-offset needed on the top boundary to correctly refer to boundary ghost points  
-      INTEGER(iwp) ::  nw   !< n-index for workarrc_t
-      INTEGER(iwp) ::  var_flag  !<
-      
-      REAL(wp) ::  cellsum     !<
-      REAL(wp) ::  cellsumd    !<
-      REAL(wp) ::  fac
-      REAL(wp) ::  fk          !<
-      REAL(wp) ::  fkj         !<
-      REAL(wp) ::  fkjp        !<
-      REAL(wp) ::  fkpj        !<
-      REAL(wp) ::  fkpjp       !<
-      REAL(wp) ::  fkp         !<
-      REAL(wp) ::  f_interp    !<
-      REAL(wp) ::  rcorr       !<
-      REAL(wp) ::  rcorr_ijk   !<
-
-!      real(wp), parameter :: c1 =  2.0_wp / 6.0_wp
-!      real(wp), parameter :: c2 =  5.0_wp / 6.0_wp
-!      real(wp), parameter :: c3 = -1.0_wp / 6.0_wp
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f    !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc   !< Parent-grid array
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN)    ::  ifl  !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN)    ::  ifu  !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN)    ::  jfl  !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN)    ::  jfu  !< Indicates end index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp) :: kct                                        !< The parent-grid index in z-direction just below the boundary value node
+      CHARACTER(LEN=1), INTENT(IN) :: var                        !< Variable symbol: 'u', 'v', 'w' or 's'
+!
+!--   Local variables:
+      REAL(wp)     ::  c31         !< Interpolation coefficient for the 3rd-order WS scheme
+      REAL(wp)     ::  c32         !< Interpolation coefficient for the 3rd-order WS scheme
+      REAL(wp)     ::  c33         !< Interpolation coefficient for the 3rd-order WS scheme
+      REAL(wp)     ::  f_interp_1  !< Value interpolated in z direction from the parent-grid data
+      REAL(wp)     ::  f_interp_2  !< Auxiliary value interpolated in z direction from the parent-grid data
+      INTEGER(iwp) ::  i           !< Child-grid index in x-direction
+      INTEGER(iwp) ::  iclc        !< Lower i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  icrc        !< Upper i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  ierr        !< MPI error code
+      INTEGER(iwp) ::  j           !< Child-grid index in y-direction
+      INTEGER(iwp) ::  jcsc        !< Lower j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  jcnc        !< Upper j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  k           !< Vertical child-grid index fixed to the boundary-value level 
+      INTEGER(iwp) ::  l           !< Parent-grid index in x-direction
+      INTEGER(iwp) ::  m           !< Parent-grid index in y-direction
+      INTEGER(iwp) ::  nw          !< Reduced n-index for workarrc_t pointing to the boundary ghost node 
 
 
       IF ( var == 'w' )  THEN
          k    = nzt
-         noff = 0
       ELSE
          k    = nzt + 1
-         noff = 1
       ENDIF
-
-      IF ( var == 'u' )  THEN 
-         var_flag = 1 
-      ELSEIF ( var == 'v' )  THEN
-         var_flag = 2      
-      ELSEIF ( var == 'w' )  THEN
-         var_flag = 3
-      ELSE
-         var_flag = 0
-      ENDIF
-      n  = kc(k) + noff     ! Chance this to get rid of kc. 
-      nw = noff 
-!      write(9,"(a1,2x,5(i3,2x))") var, k, kc(k), noff, n, nw 
-!      flush(9)
+      nw = 1
+!
+!--   Interpolation coefficients
+      IF  ( interpolation_scheme_t == 1 )  THEN
+         c31 =  0.0_wp           ! 1st-order upwind
+         c32 =  1.0_wp
+         c33 =  0.0_wp
+      ELSE IF  ( interpolation_scheme_t == 2 )  THEN
+         c31 =  0.5_wp           ! 2nd-order central
+         c32 =  0.5_wp
+         c33 =  0.0_wp
+      ELSE            
+         c31 =  2.0_wp / 6.0_wp  ! 3rd-order WS upwind biased (default)
+         c32 =  5.0_wp / 6.0_wp
+         c33 = -1.0_wp / 6.0_wp         
+      ENDIF         
 !
 !--   Substitute the necessary parent-grid data to the work array. 
@@ -6523,5 +3943,5 @@
       ENDIF
       workarrc_t = 0.0_wp
-      workarrc_t(0:2,jcsc:jcnc,iclc:icrc) = fc(kc(k):kc(k)+2,jcsc:jcnc,iclc:icrc)
+      workarrc_t(-2:3,jcsc:jcnc,iclc:icrc) = fc(kct-2:kct+3,jcsc:jcnc,iclc:icrc)
 !
 !--   Left-right exchange if more than one PE subdomain in the x-direction.
@@ -6567,18 +3987,40 @@
 #endif      
 
-      IF  ( var == 'u' )  THEN
+      IF  ( var == 'w' )  THEN
+         DO  l = iclw, icrw
+            DO  m = jcsw, jcnw
+ 
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     f(k,j,i) = workarrc_t(nw,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'u' )  THEN
 
          DO  l = iclw, icrw-1
             DO  m = jcsw, jcnw
 !
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+               f_interp_1 = c31 * workarrc_t(nw-1,m,l)   + c32 * workarrc_t(nw,m,l)   + c33 * workarrc_t(nw+1,m,l)
+               f_interp_2 = c31 * workarrc_t(nw-1,m,l+1) + c32 * workarrc_t(nw,m,l+1) + c33 * workarrc_t(nw+1,m,l+1)
+!
 !--            Use averages of the neighbouring matching grid-line values
                DO  i = ifl(l), ifl(l+1)
-                  f(k,jfl(m):jfu(m),i) = 0.5_wp * ( workarrc_t(nw,m,l)   &
-                       + workarrc_t(nw,m,l+1) )
+!                  f(k,jfl(m):jfu(m),i) = 0.5_wp * ( workarrc_t(nw,m,l)   &
+!                       + workarrc_t(nw,m,l+1) )
+                  f(k,jfl(m):jfu(m),i) = 0.5_wp * ( f_interp_1 + f_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
                IF  ( MOD( ifl(l), igsr ) == 0 )  THEN
-                  f(k,jfl(m):jfu(m),ifl(l)) = workarrc_t(nw,m,l)
+!
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+                  f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)                  
+!                  f(k,jfl(m):jfu(m),ifl(l)) = workarrc_t(nw,m,l)
+                  f(k,jfl(m):jfu(m),ifl(l)) = f_interp_1
                ENDIF
 
@@ -6589,5 +4031,9 @@
          IF  ( MOD( ifl(icrw), igsr ) == 0 )  THEN
             DO  m = jcsw, jcnw
-               f(k,jfl(m):jfu(m),ifl(icrw)) = workarrc_t(nw,m,icrw)
+!
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+               f_interp_1 = c31 * workarrc_t(nw-1,m,icrw) + c32 * workarrc_t(nw,m,icrw) + c33 * workarrc_t(nw+1,m,icrw)
+!               f(k,jfl(m):jfu(m),ifl(icrw)) = workarrc_t(nw,m,icrw)
+               f(k,jfl(m):jfu(m),ifl(icrw)) = f_interp_1
             ENDDO
          ENDIF
@@ -6610,13 +4056,20 @@
             DO  m = jcsw, jcnw-1
 !
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+               f_interp_1 = c31 * workarrc_t(nw-1,m,l)   + c32 * workarrc_t(nw,m,l)   + c33 * workarrc_t(nw+1,m,l)
+               f_interp_2 = c31 * workarrc_t(nw-1,m+1,l) + c32 * workarrc_t(nw,m+1,l) + c33 * workarrc_t(nw+1,m+1,l)
+!
 !--            Use averages of the neighbouring matching grid-line values
-               DO  j = jfl(m), jfl(m+1)                  
-                  f(k,j,ifl(l):ifu(l)) = 0.5_wp * ( workarrc_t(nw,m,l)   &
-                       + workarrc_t(nw,m+1,l) )
+               DO  j = jfl(m), jfl(m+1)          
+!                  f(k,j,ifl(l):ifu(l)) = 0.5_wp * ( workarrc_t(nw,m,l)   &
+!                       + workarrc_t(nw,m+1,l) )
+                  f(k,j,ifl(l):ifu(l)) = 0.5_wp * ( f_interp_1 + f_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
                IF  ( MOD( jfl(m), jgsr ) == 0 )  THEN
-                  f(k,jfl(m),ifl(l):ifu(l)) = workarrc_t(nw,m,l)
+                  f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)
+!                  f(k,jfl(m),ifl(l):ifu(l)) = workarrc_t(nw,m,l)
+                  f(k,jfl(m),ifl(l):ifu(l)) = f_interp_1
                ENDIF
                
@@ -6625,8 +4078,12 @@
          ENDDO
 !
-!--      Finally, set the values along the last matching grid-line  
+!--      Finally, set the values along the last matching grid-line
          IF  ( MOD( jfl(jcnw), jgsr ) == 0 )  THEN
             DO  l = iclw, icrw
-               f(k,jfl(jcnw),ifl(l):ifu(l)) = workarrc_t(nw,jcnw,l)
+!
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+               f_interp_1 = c31 * workarrc_t(nw-1,jcnw,l) + c32 * workarrc_t(nw,jcnw,l) + c33 * workarrc_t(nw+1,jcnw,l)
+!               f(k,jfl(jcnw),ifl(l):ifu(l)) = workarrc_t(nw,jcnw,l)
+               f(k,jfl(jcnw),ifl(l):ifu(l)) = f_interp_1
             ENDDO
          ENDIF
@@ -6644,18 +4101,15 @@
          ENDIF
 
-      ELSE  ! w or any scalar
+      ELSE  ! any scalar variable
 
          DO  l = iclw, icrw
             DO  m = jcsw, jcnw
 !
-!--            3rd-order upwind biased interpolation. 
-!               IF  ( w(k,jfl(m),ifl(l)) < 0.0_wp )  THEN
-!                  f_interp = c1 * workarrc_t(0,m,l) + c2 * workarrc_t(1,m,l) + c3 * workarrc_t(2,m,l) 
-!               ELSE
-!                  f_interp = workarrc_t(nw,m,l)
-!               ENDIF              
+!--            First interpolate to the flux point using the 3rd-order WS scheme
+               f_interp_1 = c31 * workarrc_t(nw-1,m,l) + c32 * workarrc_t(nw,m,l) + c33 * workarrc_t(nw+1,m,l)
                DO  i = ifl(l), ifu(l)
                   DO  j = jfl(m), jfu(m)
-                     f(k,j,i) = workarrc_t(nw,m,l)
+!                     f(k,j,i) = workarrc_t(nw,m,l)
+                     f(k,j,i) = f_interp_1
                   ENDDO
                ENDDO
